<template>
  <div>
    <AppWindow
        v-bind:show="show"
        title="Add new particle"
        cancelable
        @canceled="() => this.$emit('canceled')"
        width="700"
        @submitted="addBtnClick"
        :disabled-submit="!validForm"
    >
      <br>
      <span class="heading">Preset :</span>&nbsp;&nbsp;
      <v-btn outlined color="blue" small @click="setElectronPreset">Electron</v-btn>
      &nbsp;&nbsp;
      <v-btn outlined color="red" small @click="setNeutronPreset">Proton</v-btn>
      <v-form v-model="validForm">
        <v-row>
          <v-col>
            <v-text-field
                label="Position X"
                v-model="tempParticle.pos.x"
                color="secondary"
                suffix="m"
                hint="eg: 5e-9"
                :rules="[isNumber, notEmpty]"
            ></v-text-field>
          </v-col>
          <v-col>
            <v-text-field
                label="Position Y"
                v-model="tempParticle.pos.y"
                color="secondary"
                suffix="m"
                hint="eg: 5e-9"
                :rules="[isNumber, notEmpty]"
            ></v-text-field>
          </v-col>
        </v-row>
        <v-row>
          <v-col>
            <v-text-field
                label="Charge"
                v-model="tempParticle.q"
                color="secondary"
                suffix="C"
                hint="eg: 6e-12"
                :rules="[isNumber, notEmpty]"
            ></v-text-field>
          </v-col>
          <v-col>
            <v-text-field
                label="Mass"
                v-model="tempParticle.m"
                color="secondary"
                suffix="kg"
                hint="eg: 5e-9"
                :rules="[isNumber, notNul, notEmpty]"
            ></v-text-field>
          </v-col>
          <v-col>
            <v-checkbox
                color="secondary"
                v-model="tempParticle.locked"
                label="Locked"
            ></v-checkbox>
          </v-col>
        </v-row>
      </v-form>

      <template v-slot:submit-text>
        Add
      </template>
    </AppWindow>
  </div>
</template>

<script>
import AppWindow from './../AppWindow/AppWindow'
import {AppContext} from '@Util'

const electronPreset = {q: '-1.602e-19', m: '9.1094e-31'}
const protonPreset = {q: '1.602e-19', m: '1.6726219e-27'}

const defaultParticle = {
  pos: {x: '0', y: '0'},
  q: '0',
  m: '0',
  locked: false
}

export default {
  name: 'AddParticle',
  components: {
    AppWindow
  },
  props: {
    show: Boolean
  },
  data: () => ({
    tempParticle: defaultParticle,
    isNumber: val => !isNaN(Number(val)) || `${val} is not a valid number`,
    notNul: val => val !== '0' || 'Must be different from 0',
    notEmpty: val => val !== '' || `Can't be empty`,
    validForm: false,
   }),
  watch: {
    show(val) {
      this.tempParticle = JSON.parse(JSON.stringify(defaultParticle))
      Object.assign(AppContext, {mode: val ? 0 : 2})
    }
  },
  methods: {
    setElectronPreset() {
      this.tempParticle.m = electronPreset.m
      this.tempParticle.q = electronPreset.q
    },

    setNeutronPreset() {
      this.tempParticle.m = protonPreset.m
      this.tempParticle.q = protonPreset.q
    },
    addBtnClick() {
      AppContext.currentProject.AddParticle({
        pos: {
          x: Number(this.tempParticle.pos.x),
          y: Number(this.tempParticle.pos.y)
        },
        q: Number(this.tempParticle.q),
        m: Number(this.tempParticle.m)
      })
      AppContext.currentProject.Save()
      this.$emit('saved')
    }
  }
}
</script>